;made by linkunarre
PRINT "INIT ",pc

RTL

PRINT "MAIN ",pc

PHB                ;\
PHK                ; | Change the data bank to the one our code is running from.
PLB                ; | This is a good practice.
JSR SpriteCode        ; | Jump to the sprite's function.
PLB                ; | Restore old data bank.
RTL                ;/ And return.

;===================================
;Sprite Function
;===================================

RETURN: RTS

SpriteCode:
        JSR Graphics

        LDA $14C8,x                        ;\
        CMP #$08                        ; | If sprite dead,
        BNE RETURN                        ;/ Return.
        LDA $9D                                ;\
        BNE RETURN                        ;/ If locked, return.

        JSR SUB_OFF_SCREEN_X0                ; Handle offscreen.
        
        JSR ObjectCol
        JSR MarioCol
        JSR SetSpeed
        JSR TimerDec
        JSL $01802A
        STZ $AA,x
                
        RTS
        
SetSpeed:

    LDA $1504,x
    CMP #$00
    BEQ continuar

    STZ $B6,x
    RTS
    
    continuar:
    LDA $157C,x
    CMP #$00
    BEQ right
    
    DEC $B6,x
    
    LDA $B6,x
    BEQ retl
    CMP #$F0
    BCC retl
    LDA #$F0
    STA $B6,x

retl:
RTS

right:

    INC $B6,x
    
    LDA $B6,x
    CMP #$10
    BCS retr
    LDA #$10
    STA $B6,x

retr:

RTS

ObjectCol:

    LDA $1588,x
    AND #$03
    BEQ returnObjectcol
    
    LDA $151C,x
    CMP #$00
    BNE proseguir2
    
    LDA #$01
    STA $151C,x ; Direcion condicional para el timer
    
    LDA #$78
    STA $1504,x ; Direción del timer
    
    proseguir2:   
    LDA $157C,x
    BEQ right3
    STZ $157C,x
    RTS
    right3:
    LDA #$01
    STA $157C,x

RTS
    

returnObjectcol:
    STZ $151C,x
RTS

TimerDec:

    LDA $1504,x
    BEQ endtimer
    DEC $1504,x
    endtimer:

RTS

MarioCol:

    JSL $01A7DC
    BCC nocol
    JSL $00F5B7
    nocol:

RTS

;########################################################################
;====================================================
;================Graphics Routine====================
;====================================================

;Tables for Frames:
;###############  Tables for DerechaStop   #############
PROPERTIES_DerechaStop: db $6F
TILEMAP_DerechaStop: db $2B
XDISP_DerechaStop: db $0
YDISP_DerechaStop: db $0

;###############  Tables for IzquierdaStop   #############
PROPERTIES_IzquierdaStop: db $2F
TILEMAP_IzquierdaStop: db $2B
XDISP_IzquierdaStop: db $0
YDISP_IzquierdaStop: db $0

;###############  Tables for Derecha1   #############
PROPERTIES_Derecha1: db $6F
TILEMAP_Derecha1: db $67
XDISP_Derecha1: db $0
YDISP_Derecha1: db $0

;###############  Tables for Derecha2   #############
PROPERTIES_Derecha2: db $6F
TILEMAP_Derecha2: db $69
XDISP_Derecha2: db $0
YDISP_Derecha2: db $0

;###############  Tables for Izquierda1   #############
PROPERTIES_Izquierda1: db $2F
TILEMAP_Izquierda1: db $67
XDISP_Izquierda1: db $0
YDISP_Izquierda1: db $0

;###############  Tables for Izquierda2   #############
PROPERTIES_Izquierda2: db $2F
TILEMAP_Izquierda2: db $69
XDISP_Izquierda2: db $0
YDISP_Izquierda2: db $0

Graphics:

JSR DerechaCon_Start
JSR IzquierdaCon_Start
JSR DerechaMovCon_Start
JSR IzquierdaMovCon_Start

RTS

;########################################################################


DerechaCon_Start:
;1. Condition of DerechaCon
LDA $1504,x
CMP #$00
BEQ DerechaCon_Return

;2. Condition of DerechaCon
LDA $157C,x
CMP #$00
BNE DerechaCon_Return

BRA DerechaCon_Passed
DerechaCon_Return:
RTS
DerechaCon_Passed:

JSR DerechaStop_Start

RTS

;########################################################################


IzquierdaCon_Start:
;1. Condition of IzquierdaCon
LDA $1504,x
CMP #$00
BEQ IzquierdaCon_Return

;2. Condition of IzquierdaCon
LDA $157C,x
CMP #$01
BNE IzquierdaCon_Return

BRA IzquierdaCon_Passed
IzquierdaCon_Return:
RTS
IzquierdaCon_Passed:

JSR IzquierdaStop_Start

RTS

;########################################################################


DerechaMovCon_Start:
;1. Condition of DerechaMovCon
LDA $1504,x
CMP #$00
BNE DerechaMovCon_Return

;2. Condition of DerechaMovCon
LDA $157C,x
CMP #$00
BNE DerechaMovCon_Return

BRA DerechaMovCon_Passed
DerechaMovCon_Return:
RTS
DerechaMovCon_Passed:

JSR Derecha_Start

RTS

;########################################################################


IzquierdaMovCon_Start:
;1. Condition of IzquierdaMovCon
LDA $1504,x
CMP #$00
BNE IzquierdaMovCon_Return

;2. Condition of IzquierdaMovCon
LDA $157C,x
CMP #$01
BNE IzquierdaMovCon_Return

BRA IzquierdaMovCon_Passed
IzquierdaMovCon_Return:
RTS
IzquierdaMovCon_Passed:

JSR Izquierda_Start

RTS

;########################################################################


Derecha_Start:
LDA $14
LSR A
LSR A
AND #$1
Derecha_Frame_1:
CMP #$0
BNE Derecha_Frame_2
JSR Derecha1_Start
BRA Derecha_End_Code

Derecha_Frame_2:
CMP #$1
BNE Derecha_Frame_3
JSR Derecha2_Start
BRA Derecha_End_Code

Derecha_Frame_3:
Derecha_End_Code:

;Your Code for Derecha
;Hallo

RTS

;########################################################################


Izquierda_Start:
LDA $14
LSR A
LSR A
AND #$1
Izquierda_Frame_1:
CMP #$0
BNE Izquierda_Frame_2
JSR Izquierda1_Start
BRA Izquierda_End_Code

Izquierda_Frame_2:
CMP #$1
BNE Izquierda_Frame_3
JSR Izquierda2_Start
BRA Izquierda_End_Code

Izquierda_Frame_3:
Izquierda_End_Code:

;Your Code for Izquierda
;Hallo

RTS

;########################################################################



DerechaStop_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_DerechaStop:
LDA $00
CLC
ADC XDISP_DerechaStop,x
STA $0300,y

LDA $01
CLC
ADC YDISP_DerechaStop,x
STA $0301,y

LDA TILEMAP_DerechaStop,x
STA $0302,y

LDA PROPERTIES_DerechaStop,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_DerechaStop
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



IzquierdaStop_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_IzquierdaStop:
LDA $00
CLC
ADC XDISP_IzquierdaStop,x
STA $0300,y

LDA $01
CLC
ADC YDISP_IzquierdaStop,x
STA $0301,y

LDA TILEMAP_IzquierdaStop,x
STA $0302,y

LDA PROPERTIES_IzquierdaStop,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_IzquierdaStop
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



Derecha1_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_Derecha1:
LDA $00
CLC
ADC XDISP_Derecha1,x
STA $0300,y

LDA $01
CLC
ADC YDISP_Derecha1,x
STA $0301,y

LDA TILEMAP_Derecha1,x
STA $0302,y

LDA PROPERTIES_Derecha1,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_Derecha1
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



Derecha2_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_Derecha2:
LDA $00
CLC
ADC XDISP_Derecha2,x
STA $0300,y

LDA $01
CLC
ADC YDISP_Derecha2,x
STA $0301,y

LDA TILEMAP_Derecha2,x
STA $0302,y

LDA PROPERTIES_Derecha2,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_Derecha2
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



Izquierda1_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_Izquierda1:
LDA $00
CLC
ADC XDISP_Izquierda1,x
STA $0300,y

LDA $01
CLC
ADC YDISP_Izquierda1,x
STA $0301,y

LDA TILEMAP_Izquierda1,x
STA $0302,y

LDA PROPERTIES_Izquierda1,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_Izquierda1
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



Izquierda2_Start:
JSR GET_DRAW_INFO

PHX
LDX #$0
Loop_Izquierda2:
LDA $00
CLC
ADC XDISP_Izquierda2,x
STA $0300,y

LDA $01
CLC
ADC YDISP_Izquierda2,x
STA $0301,y

LDA TILEMAP_Izquierda2,x
STA $0302,y

LDA PROPERTIES_Izquierda2,x
ORA $64
STA $0303,y

INY
INY
INY
INY

DEX
BPL Loop_Izquierda2
PLX

LDY #$02
LDA #$0
JSL $01B7B3
RTS


;########################################################################



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90                ;bank 1 sizes
                            db $30,$C0,$A0,$80,$A0,$40,$60,$B0                ;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF                ;bank 1 sizes
                                        db $01,$FF,$01,$FF,$01,$00,$01,$FF                ;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:                        STA $03                                        ;  |            
                                        BRA START_SUB                        ;  |
SUB_OFF_SCREEN_X0:   STZ $03                                        ; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / 
